#pragma once
#include "RenderingRun.h"

/**
	@brief Base abstract class that defines a rendering process that creates depth map fro the camera.

	The depth map stores the scene's camera space z coordinates (rendered from the player's view).
*/
class SceneCameraDepthRenderingRun : virtual public RenderingRun
{	
public:
	/**
		@brief Constructor.
	*/
	SceneCameraDepthRenderingRun()
							:RenderingRun(1, 1)
	{
	}

protected:
    
	/**
		@brief Creates the depth map texture.
	*/
	virtual inline void createDepthMap() = 0;	
	//inherited
	virtual void updateFrame(unsigned long frameNum) = 0;	
};
